# -*- coding: UTF-8 -*-
import gtk, gnomevfs
import os, re, pprint
import string, sys
import utils
import fstypes


class Reader:
	""" Lector de ficheros """

	def __init__(self):
		self._cancel_import_disk = False
		
	
	def read(self, path, progress = None, recursive = None):
		pos = 0; files = []; dirs = [];
		""" La primera vez que se llama """
		if not recursive: 			
			self._cancel_import_disk = False
			self.count_files = 1;	self.position = 0;	self.root = path
			
			utils.mount_if_not_is_mounted(path)
			""" Creamos un nuevo disco """
			self.disk = fstypes.Disk(utils.get_label(path), path)						
			
			# Contamos los archivos primero, para luego poder poner el progreso
			for root, dirs, tfiles in os.walk(path): self.count_files = self.count_files + len(tfiles)		
	
		self.__update_progress(progress, path)		
		
		# Obtenemos la estructura del disco
		for file in os.listdir(path):

			self.__update_progress(progress, path)			
			if(self._cancel_import_disk): return None			
			
			""" Insertamos el archivo, si no es un archivo oculto """
			if file[0] != ".": 
				pathfile = os.path.join(path, file)
				
				""" Añadimos el fichero al disco """
				file = fstypes.File(pathfile, self.disk)
				if file.is_dir():  file.add_files(self.read(pathfile, None, True))				
				self.position = self.position + 1							
				files.append(file)			
				if not recursive: self.disk.add(file)
		
		if(self._cancel_import_disk): return None			
		if not recursive: 
			return self.disk
		else:			
			return files

	def __update_progress(self, progress = None, path = None):
		if not progress: return
		if self.position > self.count_files: self.position = self.count_files
		while (gtk.events_pending ()): gtk.main_iteration ();
		if path: progress.set_text(_("Importando ") + path  + " (" +  str(self.position) + "/" + str(self.count_files) + ")")
		progress.set_fraction(float(self.position) / float(self.count_files))

	def cancel_import_disk(self):	
		self._cancel_import_disk = True
		

if __name__ == "__main__":
	reader = Reader()
#	pprint.pprint(reader.read("/home/jose/Desktop"))
#	pprint.pprint(reader.read("/home/jose/Desktop/Peliculas"))
#	print reader.read("/home/jose")