import gtk, gtk.glade, gconf, gnomevfs, os, string, commands, md5, urllib

class Thumb:
	
	def __init__(self):
		self.conf_client = gconf.client_get_default()
		self.thumbnailers = {}
	
	def get(self, file):
		
		try:
			type, subtype = string.split(file.mime, "/")
		except: 
			print file.mime
			return None
		
		if type == "audio" or subtype == "ogg": return None						

		data = self.__get_existing(file.path)		
		if data: return data

		data =  self.__generate(file)
		if data: return data
		return None		

	
		
	def __get_path(self, pathfile):
		return os.environ['HOME'] + "/.thumbnails/normal/" + md5.new("file://" + urllib.pathname2url(pathfile.path)).hexdigest() + ".png"

	""" Genera un nuevo thumb para el fichero """
	def __generate(self, file):
		type, subtype = string.split(file.mime, "/")					
		thumbPath = self.__get_path(file.path)		
		if type == "image":
			try:
				gtk.gdk.pixbuf_new_from_file_at_size(str(file.path)[7:], 128, 128).save(thumbPath, "png")
			except:			
				return None
				
			data = open(thumbPath, "rb").read()
			return data
			
		else:
			thumbnailer = self.__get_thumbnailers(type + "@" + subtype, file.path)

			if thumbnailer != None:
				output = commands.getoutput(thumbnailer)
				return self.__get_existing(file.path)

	""" Busca para ver si ya ha sido generado """
	def __get_existing(self, pathfile): 
		path = self.__get_path(pathfile)
		if os.path.exists(path):
			return open(path, "rb").read()
									

	def __get_thumbnailers(self, mime, pathfile = ""):

		if self.thumbnailers.has_key(mime):
			thumbnailer = self.thumbnailers[mime]
		else:
			thumbnailer = self.conf_client.get_string("/desktop/gnome/thumbnailers/" + mime + "/command")		
			self.thumbnailers[mime] = thumbnailer
			
		if thumbnailer == None or thumbnailer == "": return None
		thumbnailer = string.replace(thumbnailer, "%s", "128x128")
		thumbnailer = string.replace(thumbnailer, "%u", "file://" + urllib.pathname2url(pathfile.path))
		thumbnailer = string.replace(thumbnailer, "%o", self.__get_path(pathfile))
		print "Thumbnailer :", thumbnailer
		return thumbnailer

						
if __name__ == "__main__":
	t = Thumb()
#	t.stat("test.jpg")
#	t.getThumbnail("/home/jose/Desktop/quickstart.pdf", "");
	
	
