import os, commands, time
import gnomevfs

def locate_file(path, type = "icons"):
	prefixes = ['', 'usr/', 'usr/local/']
	if type == "glade":
		subs = ["share/gnomecatalog/glade", "share/glade"];

	elif type == "icons" or  type == "pixmap":
		subs = ["share/gnomecatalog/pixmaps", "share/pixmaps"];

	# Try them locally
	for prefix in prefixes:
		for sub in subs:
			if os.path.exists(prefix + os.path.join(".." ,sub, path)): 
				return prefix + os.path.join(".." ,sub, path);

	# Try them from root
	for prefix in prefixes:
		for sub in subs:
			if os.path.exists('/' + prefix + os.path.join(sub, path)): 
				return '/' + prefix + os.path.join(sub, path)

	return None


def getSize(size):
	if not size or size == None: return ""		
	if size > 1024 * 1024 * 1024:
		return str(round(float(size) / (1024 * 1024 * 1024),2)) + " Gb"
	elif size > 1024 * 1024:
		return str(size / (1024 * 1024)) + " Mb"
	elif size > 1024:
		return str(size / 1024) + " Kb"
	else:
		return str(size) +	"b"		

def encode(txt):
#	txt = unicode(txt, "utf-8")
	txt = str(txt).replace("&", "&amp;")

	try:
		txt  =txt.encode("utf-8", "replace")
	except:
		txt = unicode(txt, 'iso-8859-15').encode('utf-8')
	
	
	return txt


def get_label(path):
	drive = gnomevfs.VolumeMonitor().get_volume_for_path(path)
	if drive:	
		print "label:",drive.get_display_name()
		return drive.get_display_name()

def callback_eject(data, data1, data2): pass
	
def eject(path):
	try:
		drive = gnomevfs.VolumeMonitor().get_volume_for_path(path).get_drive()
	except: pass
	
	if drive:	
		return drive.eject(callback_eject)		

def mount_if_not_is_mounted(path):
	print path
	try:
		drive = gnomevfs.VolumeMonitor().get_volume_for_path(encode(path)).get_drive()
	except: pass
	
	if not drive:	
		commands.getoutput('pmount ' + path)
		for i in xrange(4):
  			time.sleep(1)
		